Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 10)
@@ -0,0 +1,403 @@
+package geniusweb.protocol.session.shaop;
+
+import java.io.IOException;
+import java.sql.Date;
+import java.text.SimpleDateFormat;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Timer;
+import java.util.TimerTask;
+import java.util.concurrent.atomic.AtomicBoolean;
+import java.util.logging.Level;
+import java.util.stream.Collectors;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.Comparison;
+import geniusweb.actions.ElicitComparison;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.deadline.Deadline;
+import geniusweb.events.ProtocolEvent;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
+import geniusweb.progress.ProgressFactory;
+import geniusweb.protocol.CurrentNegoState;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.session.SessionProtocol;
+import geniusweb.protocol.session.SessionState;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.logging.Reporter;
+import tudelft.utilities.repository.NoResourcesNowException;
+
+/**
+ * 
+ * This is similar to SAOP but there are two types of parties: a SHAOP party and
+ * an a COB party associated with each SHAOP party.
+ * <p>
+ * Each SHAOP must receive a parameter: elicitationcost containing a Double. A
+ * party of this type can execute a RequestComparison(userid) action, which
+ * increases the total bother with the elicitationcost. The call results in the
+ * associated COB party to execute a Comparison action.
+ * <p>
+ * A SHAOP party keeps the turn until it does an action that is not a
+ * {@link ElicitComparison}. A COB party also receives all ActionDone if a party
+ * does an action. The party takes an action only after CompareWithBid is
+ * received. It reacts with a Comparison action.
+ * <p>
+ * The Comparison/ComparisonTest actions are private between the
+ * {@link ShaopTeam}. A SHAOP party can do a {@link ElicitComparison} action
+ * at any time. These actions are completely transparent to the other parties
+ * and are not dependent or influencing the normal turn taking.
+ */
+public class SHAOP extends DefaultListenable<ProtocolEvent>
+		implements SessionProtocol {
+	/**
+	 * Tech note: We can not just extend SAOP because SHAOPState and
+	 * SHAOPSettings do not extend SAOPState and SAOPSettings
+	 */
+	public static final int TIME_MARGIN = 20;// ms extra delay after deadline
+	public static final int MINDURATION = 100;
+	public static final int MIN_SLEEP_TIME = 1000;
+	public static final int MAX_SLEEP_TIME = 60000;
+	private static final ProtocolRef SHAOP = new ProtocolRef("SHAOP");
+	private final Reporter log;
+
+	private SHAOPState state = null; // mutable!
+	private volatile AtomicBoolean isFinishedInfoSent = new AtomicBoolean(
+			false);
+	private volatile Timer deadlinetimer = null;
+	private List<Class> ALLOWED_ACTIONS = Arrays.asList(Offer.class,
+			ElicitComparison.class, Accept.class, EndNegotiation.class);
+
+	/**
+	 * 
+	 * @param state normally the initial state coming from SAOPSettings
+	 */
+	public SHAOP(SHAOPState state, Reporter logger) {
+		if (state == null) {
+			throw new NullPointerException("state must be not null");
+		}
+		if (state.getSettings().getDeadline().getDuration() < MINDURATION) {
+			throw new IllegalArgumentException(
+					"Duration must be at least " + MINDURATION);
+		}
+		this.log = logger;
+		this.state = state;
+	}
+
+	@Override
+	public synchronized void start(
+			ProtocolToPartyConnFactory connectionfactory) {
+
+		try {
+			connect(connectionfactory);
+			setDeadline();
+			setupParties();
+			nextTurn();
+		} catch (Throwable e) {
+			handleError("Failed to start up session", null, e);
+		}
+	}
+
+	@Override
+	public String getDescription() {
+		return "We iterate through all PartiesTuple's, first the shaop party and then the cob party. Each gets "
+				+ "YourTurn in clockwise order, after which they can do their next action. "
+				+ "No new participants after start. End after prescribed deadline or when some bid is unanimously Accepted."
+				+ "Parties can only act on their own behalf and only when it is their turn."
+				+ "COB requests and actions are stored in the actions list but not broadcasted."
+				+ "A SHAOP party keeps the turn until it does a non-COB request (Accept, Offer, EndNegotiation).";
+
+	}
+
+	@Override
+	public void addParticipant(PartyWithProfile party)
+			throws IllegalStateException {
+		throw new IllegalStateException(
+				"Dynamic joining a negotiation is not allowed in SHAOP");
+	}
+
+	@Override
+	public SessionState getState() {
+		return state;
+	}
+
+	@Override
+	public ProtocolRef getRef() {
+		return SHAOP;
+	}
+
+	/*******************************************************************
+	 * private functions. Some are protected only, for testing purposes
+	 ********************************************************************/
+	/**
+	 * step 1 in protocol: connect all involved parties and start the clock.
+	 * This always "succeeds" with a valid (but possibly final) state
+	 * <p>
+	 * This is 'protected' to allow junit testing, this code is not a 'public'
+	 * part of the interface.
+	 * 
+	 * @param connectionfactory the connectionfactory for making party
+	 *                          connections
+	 * 
+	 * @throws InterruptedException if the connection procedure is unterrupted
+	 * 
+	 * @throws IOException          if this fails to properly conect to the
+	 *                              parties, eg interrupted or server not
+	 *                              responding..
+	 */
+	protected synchronized void connect(
+			ProtocolToPartyConnFactory connectionfactory)
+			throws InterruptedException, IOException {
+		List<PartyWithProfile> participants = state.getSettings()
+				.getTeams().stream().map(team -> team.getAllParties())
+				.flatMap(List::stream).collect(Collectors.toList());
+		List<Reference> parties = participants.stream()
+				.map(parti -> (parti.getParty().getPartyRef()))
+				.collect(Collectors.toList());
+		List<ProtocolToPartyConn> connections = null;
+		log.log(Level.INFO, "SHAOP connect " + parties);
+		while (connections == null) {
+			try {
+				connections = connectionfactory.connect(parties);
+			} catch (NoResourcesNowException e) {
+				long waitms = e.getLater().getTime()
+						- System.currentTimeMillis();
+				log.log(Level.INFO,
+						"No resources available to run session, waiting"
+								+ waitms);
+				Thread.sleep(Math.min(MAX_SLEEP_TIME,
+						Math.max(MIN_SLEEP_TIME, waitms)));
+			}
+		}
+		for (int i = 0; i < participants.size(); i++) {
+			setState(this.state.with(connections.get(i)));
+		}
+	}
+
+	/**
+	 * Set state to proper deadline. Starts the timer tasks. This tasks triggers
+	 * a call to handleError when the session times out.
+	 */
+	private synchronized void setDeadline() {
+		long now = System.currentTimeMillis();
+		Deadline deadline = state.getSettings().getDeadline();
+		setState(state.with(ProgressFactory.create(deadline, now)));
+		deadlinetimer = new Timer();
+		TimerTask task = new TimerTask() {
+			@Override
+			public void run() {
+				if (!state.isFinal(System.currentTimeMillis())) {
+					log.log(Level.SEVERE,
+							"BUG. Deadline timer has triggered but state is not final");
+				}
+				log.log(Level.WARNING,
+						"SHAOP deadline reached. Terminating session.");
+				finish();
+			}
+		};
+// set timer TIME_MARGIN after real deadline to ensure we're not too
+// early
+		deadlinetimer.schedule(task, deadline.getDuration() + TIME_MARGIN);
+		log.log(Level.INFO, "SHAOP deadline set to "
+				+ new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")
+						.format(new Date(System.currentTimeMillis()
+								+ deadline.getDuration() + TIME_MARGIN)));
+	}
+
+	/**
+	 * step 2 in protocol: listen to connections and send settings to the
+	 * parties.
+	 * <p>
+	 * This is 'protected' to allow junit testing, this code is not a 'public'
+	 * part of the interface.
+	 * 
+	 * @throws ProtocolException if a party does not follow the protocol
+	 */
+	protected synchronized void setupParties() throws ProtocolException {
+		for (ProtocolToPartyConn conn : state.connections) {
+			conn.addListener(action -> actionRequest(conn, action));
+		}
+
+		for (ProtocolToPartyConn connection : state.connections) {
+			try {
+				sendSettings(connection);
+			} catch (IOException e) {
+				throw new ProtocolException("Failed to initialize",
+						connection.getParty().getName(), e);
+			}
+		}
+
+	}
+
+	/**
+	 * Inform a party about its settings
+	 * 
+	 * @param connection
+	 * @throws IOException if party got disconnected
+	 */
+	private synchronized void sendSettings(ProtocolToPartyConn connection)
+			throws IOException {
+		PartyId partyid = connection.getParty();
+		PartyWithProfile settings = state.getPartyProfile(partyid);
+		ProfileRef profile = settings.getProfile();
+		Parameters params = settings.getParty().getParameters();
+		connection.send(new Settings(connection.getParty(), profile, getRef(),
+				state.getProgress(), params));
+	}
+
+	/**
+	 * This is called when one of the party connections does an action.
+	 * Synchronized so that we always handle only 1 action at a time. This is
+	 * also called when a connection closes down, but then with a null action.
+	 * 
+	 * @param partyconn the connection on which the action came in
+	 * @param action    the {@link Action} taken by some party
+	 */
+	protected synchronized void actionRequest(
+			final ProtocolToPartyConn partyconn, final Action action) {
+		try {
+			if (partyconn.getError() != null)
+				throw partyconn.getError();
+			actionRequest1(partyconn, action);
+		} catch (Throwable e) {
+			handleError("failed to handle action " + action,
+					partyconn.getParty().getName(), e);
+		}
+	}
+
+	protected synchronized void actionRequest1(
+			final ProtocolToPartyConn partyconn, final Action action)
+			throws ProtocolException, IOException {
+		PartyId partyid = partyconn.getParty();
+		if (state.isFinal(System.currentTimeMillis())) {
+			return;
+		}
+
+		if (action == null)
+			throw new ProtocolException("Party sent a null action",
+					partyid.getName());
+
+		// check if action allowed
+		if (state.isShaopParty(partyid)) {
+			if (!ALLOWED_ACTIONS.contains(action.getClass())) {
+				throw new ProtocolException(
+						"Illegal action for SHAOP Party:" + action,
+						partyid.getName());
+			}
+		} else {
+			if (!(action instanceof Comparison))
+				throw new ProtocolException(
+						"Illegal action for COB Party:" + action,
+						partyid.getName());
+		}
+
+		// broadcast, except if this is about eliciting comparison.
+		if (action instanceof ElicitComparison
+				|| action instanceof Comparison) {
+			// send actionDone only to the partner
+			setState(state.with(partyconn.getParty(), action));
+			state.connections.get(state.getPartner(partyid))
+					.send(new ActionDone(action));
+		} else {
+			if (!partyconn.getParty().equals(state.getCurrentActor()))
+				throw new ProtocolException(
+						"Party acts without having the turn",
+						partyid.getName());
+			setState(state.with(partyconn.getParty(), action));
+			state.connections.broadcast(new ActionDone(action));
+			if (!state.isFinal(System.currentTimeMillis()))
+				nextTurn();
+		}
+
+	}
+
+	/**
+	 * Signal the current participant it's his turn
+	 * 
+	 * @throws IOException
+	 */
+	private synchronized void nextTurn() {
+		PartyId party = state.getCurrentActor();
+		try {
+			state.getConnections().get(party).send(new YourTurn());
+		} catch (IOException e) {
+			handleError("failed to send YourTurn", party.getName(), e);
+		}
+	}
+
+	/**
+	 * Update state to include the given error and finishes up the session.
+	 * 
+	 * @param message The message to attach to the error
+	 * @param party   the party where the error occured
+	 * @param e       the exception that occured.
+	 */
+	private synchronized void handleError(final String message,
+			final String party, final Throwable e) {
+		log.log(Level.WARNING, "SHAOP protocol intercepted error due to party "
+				+ party + ": " + message, e);
+		if (e instanceof ProtocolException) {
+			setState(state.with((ProtocolException) e));
+		} else {
+			setState(state.with(new ProtocolException(message, party, e)));
+		}
+	}
+
+	/**
+	 * Sets the new state. If the new state is final, the finish-up procedure is
+	 * executed.
+	 * 
+	 * @param newstate the new state.
+	 */
+	private synchronized void setState(SHAOPState newstate) {
+		long now = System.currentTimeMillis();
+		if (state.isFinal(now)) {
+			finish();
+			return;
+		}
+		this.state = newstate;
+		if (newstate.isFinal(now)) {
+			finish();
+		}
+	}
+
+	/**
+	 * Called when we reach final state. Cancels deadline timer. Send finished
+	 * info to all parties, notify current nego state as final and set
+	 * {@link #isFinishedInfoSent}. Double calls are automatically ignored.
+	 */
+	private synchronized void finish() {
+		if (deadlinetimer != null) {
+			deadlinetimer.cancel();
+			deadlinetimer = null;
+		}
+		if (!isFinishedInfoSent.compareAndSet(false, true))
+			return;
+		Inform finished = new Finished(state.getAgreement());
+		state.connections.stream().forEach(conn -> sendFinish(conn, finished));
+		notifyListeners(new CurrentNegoState(state));
+	}
+
+	private void sendFinish(ProtocolToPartyConn connection, Inform finished) {
+		try {
+			connection.send(finished);
+			connection.close();
+		} catch (Exception e) {
+			log.log(Level.INFO, "Failed to send Finished to " + connection, e);
+		}
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java	(revision 10)
@@ -0,0 +1,138 @@
+package geniusweb.protocol.session.shaop;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.deadline.Deadline;
+import geniusweb.protocol.session.SessionProtocol;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
+import geniusweb.references.PartyWithProfile;
+import tudelft.utilities.logging.Reporter;
+
+public class SHAOPSettings implements SessionSettings {
+	private final List<ShaopTeam> participants;
+	private final Deadline deadline;
+	private final transient List<PartyWithProfile> allParties = new LinkedList<>();
+
+	/**
+	 * @param teams    the list of {@link ShaopTeam}s containing the shaop
+	 *                 parties and their partner cob There must be at least 2 to
+	 *                 run the SHAOP protocol. But SHAOP can be initialized with
+	 *                 less, for use in TournamentSettings.
+	 * @param deadline the deadline settings for the session
+	 */
+	@JsonCreator
+	public SHAOPSettings(@JsonProperty("participants") List<ShaopTeam> teams,
+			@JsonProperty("deadline") Deadline deadline) {
+		if (teams == null)
+			throw new IllegalArgumentException("participants must not be null");
+		if (deadline == null)
+			throw new IllegalArgumentException("deadline must not be null");
+		this.participants = teams;
+		this.deadline = deadline;
+		// notice, order here is crucial because of way #isShaopParty works.
+		for (ShaopTeam tuple : teams) {
+			allParties.add(tuple.getShaop());
+			allParties.add(tuple.getCob());
+		}
+	}
+
+	@Override
+	public Double getMaxRunTime() {
+		return deadline.getDuration() / 1000d;
+	}
+
+	@Override
+	public SessionProtocol getProtocol(Reporter logger) {
+		return new SHAOP(new SHAOPState(this), logger);
+	}
+
+	@Override
+	public List<TeamOfPartiesAndProfiles> getTeams() {
+		// cast needed...
+		return new ArrayList<TeamOfPartiesAndProfiles>(participants);
+	}
+
+	/**
+	 * 
+	 * @param n an index number into the {@link #getTeams()} list.
+	 * @return true iff that participant is a SHAOP party.
+	 */
+	public boolean isShaopParty(int n) {
+		return (n & 1) == 0;
+	}
+
+	/**
+	 * @return the deadline for this negotiation
+	 */
+	public Deadline getDeadline() {
+		return deadline;
+	}
+
+	/**
+	 * 
+	 * @return list of all parties, the even parties (0=first element in list)
+	 *         being the SHAOP party and the next in the list the partner COB
+	 *         party.
+	 */
+	public List<PartyWithProfile> getAllParties() {
+		return participants.stream().map(team -> team.getAllParties())
+				.flatMap(Collection::stream).collect(Collectors.toList());
+	}
+
+	@Override
+	public SessionSettings with(TeamOfPartiesAndProfiles party) {
+		if (!(party instanceof ShaopTeam))
+			throw new IllegalArgumentException(
+					"Added party must be ShaopTeam but got " + party);
+		List<ShaopTeam> newparts = new LinkedList<>(participants);
+		newparts.add((ShaopTeam) party);
+		return new SHAOPSettings(newparts, deadline);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((deadline == null) ? 0 : deadline.hashCode());
+		result = prime * result
+				+ ((participants == null) ? 0 : participants.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		SHAOPSettings other = (SHAOPSettings) obj;
+		if (deadline == null) {
+			if (other.deadline != null)
+				return false;
+		} else if (!deadline.equals(other.deadline))
+			return false;
+		if (participants == null) {
+			if (other.participants != null)
+				return false;
+		} else if (!participants.equals(other.participants))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "SHAOPSettings" + participants + "," + deadline + "]";
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 10)
@@ -0,0 +1,329 @@
+package geniusweb.protocol.session.shaop;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.Comparison;
+import geniusweb.actions.ElicitComparison;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+import geniusweb.progress.Progress;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.references.PartyWithProfile;
+
+/**
+ * Immutable.
+ */
+public class SHAOPState extends BareSHAOPState {
+
+	private static final double DEFAULT_ELICITATATION_COST = 0.1d;
+
+	/**
+	 * see {@link BareSHAOPState}.
+	 */
+	@JsonCreator
+	public SHAOPState(@JsonProperty("actions") List<Action> actions,
+			@JsonProperty("connections") ProtocolToPartyConnections conns,
+			@JsonProperty("progress") Progress progress,
+			@JsonProperty("settings") SHAOPSettings settings,
+			@JsonProperty("error") ProtocolException e,
+			@JsonProperty("actorNr") int actorNr,
+			@JsonProperty("partyNumbers") Map<PartyId, Integer> partytNumbers,
+			@JsonProperty("totalSpent") Map<PartyId, Double> spent) {
+		super(actions, conns, progress, settings, e, actorNr, partytNumbers,
+				spent);
+	}
+
+	/**
+	 * Creates the initial state from the given settings
+	 * 
+	 * @param settings the {@link SHAOPSettings}
+	 */
+	public SHAOPState(SHAOPSettings settings) {
+		this(Collections.emptyList(), null, null, settings, null, 0, null,
+				null);
+	}
+
+	/**
+	 * 
+	 * @param id the {@link PartyId}
+	 * @return the {@link PartyWithProfile} for that party
+	 */
+	public PartyWithProfile getSettings(PartyId id) {
+		return settings.getAllParties().get(partyNumbers.get(id));
+	}
+
+	/**
+	 * 
+	 * @param party
+	 * @return true iff party is a SHAOP party.
+	 */
+	public boolean isShaopParty(PartyId party) {
+		return settings.isShaopParty(partyNumbers.get(party));
+	}
+
+	/**
+	 * 
+	 * @param party a Party Id
+	 * @return the PartyId of the party
+	 */
+	public PartyId getPartner(PartyId party) {
+		return connections.get(partyNumbers.get(party) ^ 1).getParty();
+	}
+
+	@Override
+	public boolean isFinal(long currentTimeMs) {
+		List<Action> acts = getActions();
+		return super.isFinal(currentTimeMs) || getAgreement() != null
+				|| (!acts.isEmpty()
+						&& acts.get(acts.size() - 1) instanceof EndNegotiation);
+	}
+
+	@Override
+	public SHAOPSettings getSettings() {
+		return settings;
+	}
+
+	/**
+	 * search back through the actions for an offer. We can not smarly limit the
+	 * search size because there can be an unlimited number of cob Comparison
+	 * actions anywhere in the list.
+	 * 
+	 * @return Bid from the most recent offer, or null if no such offer
+	 */
+	private Bid getLastBid() {
+		for (int n = actions.size() - 1; n >= 0; n--) {
+			Action action = actions.get(n);
+			if (action instanceof Offer) {
+				return ((Offer) action).getBid();
+			}
+		}
+		return null;
+	}
+
+	/**
+	 * 
+	 * @param connection the new {@link ProtocolToPartyConn} to a party
+	 * @return new SessionState with the new connection added. This call ignores
+	 *         the progress (does not check isFinal) because SAOP uses this
+	 *         during the setup where the deadline is not yet relevant. The
+	 *         connection should be informed about the partyprofile but the
+	 *         state currently indicate if that already happened or not.
+	 *         IMPORTANT. The connections MUST be made in the same order as
+	 *         {@link SHAOPSettings#getTeams()}.
+	 */
+	public SHAOPState with(ProtocolToPartyConn connection) {
+		// Only called from the SHAOP initialization phase.
+		ProtocolToPartyConnections newconns = connections.with(connection);
+		Map<PartyId, Integer> newNumbers = new HashMap<>(partyNumbers);
+		newNumbers.put(connection.getParty(), connections.size());
+		return new SHAOPState(actions, newconns, progress, settings, null,
+				actorNr, newNumbers, totalSpent);
+	}
+
+	/**
+	 * 
+	 * @param e             the error that occured
+	 * @param currentTimeMs the current time in ms since 1970, see
+	 *                      {@link System#currentTimeMillis()}
+	 * @return a new state with the error set.
+	 */
+	public SHAOPState with(ProtocolException e) {
+		return new SHAOPState(actions, connections, progress, settings, e,
+				actorNr, partyNumbers, totalSpent);
+	}
+
+	/**
+	 * Sets the progress for this session. call is ignored if progress already
+	 * set.
+	 * 
+	 * @param newprogress the new progress
+	 * @return new SAOPState with the progress set
+	 */
+	public SHAOPState with(Progress newprogress) {
+		if (newprogress == null) {
+			throw new IllegalArgumentException("newprogress must be not null");
+		}
+		if (progress != null) {
+			return this;
+		}
+		return new SHAOPState(actions, connections, newprogress, settings,
+				error, actorNr, partyNumbers, totalSpent);
+	}
+
+	@Override
+	public Bid getAgreement() {
+		List<Action> acts = getActions();
+		if (acts.isEmpty())
+			return null;
+
+		int requiredaccepts = getSettings().getTeams().size() - 1;
+
+		// check that there are requiredaccepts and find the offer before that
+		for (int n = acts.size() - 1; n >= 0; n--) {
+			Action act = acts.get(n);
+			if (act instanceof Comparison || act instanceof ElicitComparison)
+				continue;
+			if (requiredaccepts == 0 && act instanceof Offer)
+				return ((Offer) act).getBid();
+			if (!(act instanceof Accept))
+				return null;
+			requiredaccepts--;
+		}
+		return null;
+	}
+
+	/**
+	 * @param actor         the actor that did this action. Can be used to check
+	 *                      if action is valid. NOTICE caller has to make sure
+	 *                      the current state is not final.
+	 * @param action        the action that was proposed by actor.
+	 * @param currentTimeMs the current time in ms since 1970, see
+	 *                      {@link System#currentTimeMillis()}
+	 * @return new SessionState with the action added as last action.
+	 */
+
+	public SHAOPState with(PartyId actor, Action action)
+			throws IllegalArgumentException {
+
+		if (actor == null) { // this is a bug
+			throw new IllegalArgumentException("actor must not be null");
+		}
+		if (action == null) {
+			throw new IllegalArgumentException("action is null");
+		}
+		if (!actor.equals(action.getActor())) {
+			throw new IllegalArgumentException(
+					"act contains wrong credentials: " + action);
+		}
+
+		if (action instanceof ElicitComparison) {
+			return withShaopInternalAction(actor, (ElicitComparison) action);
+		}
+		if (action instanceof Comparison) {
+			return withCobInternalAction(actor, (Comparison) action);
+		}
+
+		return withShaopRealAction(actor, action);
+
+	}
+
+	private SHAOPState withCobInternalAction(PartyId actor, Comparison action)
+			throws IllegalArgumentException {
+		if (isShaopParty(actor))
+			throw new IllegalArgumentException(
+					"Illegal action, actor is not a cob party:" + action);
+		return withAction(action);
+	}
+
+	/**
+	 * 
+	 * @param actor  actor, supposedly SHAOP, did Elicit action
+	 * @param action an elicit action
+	 * @return new state
+	 * @throws ProtocolException
+	 */
+	private SHAOPState withShaopInternalAction(PartyId actor,
+			ElicitComparison action) throws IllegalArgumentException {
+		if (!isShaopParty(actor))
+			throw new IllegalArgumentException(
+					"Illegal action, actor is not a shaop party:" + action);
+		return withAction(action);
+	}
+
+	/**
+	 * update action, actorNr, and progress
+	 * 
+	 * @param action the action that was done. Elicit actions do not update
+	 *               progress
+	 * @return
+	 */
+	private SHAOPState withAction(Action action) {
+		Progress newprogress = progress;
+		Map<PartyId, Double> newSpent = new HashMap<>(totalSpent);
+		PartyId partyid = action.getActor();
+
+		List<Action> newactions = new LinkedList<>(getActions());
+		newactions.add(action);
+		int newActor = actorNr;
+		if (action instanceof ElicitComparison) {
+			Object cost = getPartyProfile(partyid).getParty().getParameters()
+					.get("elicitationcost");
+			if (!(cost instanceof Double)) {
+				cost = DEFAULT_ELICITATATION_COST;
+			}
+			Double oldSpent = totalSpent.get(partyid);
+			if (oldSpent == null) {
+				oldSpent = 0d;
+			}
+			newSpent.put(partyid, oldSpent + (Double) cost);
+
+		} else if (action instanceof Comparison) {
+			// nothing, turn remains with current SHAOP party
+		} else {
+			// shaop party does real action, move to next SHAOP party.
+			newActor = (actorNr + 2) % settings.getTeams().size();
+			if (newprogress instanceof ProgressRounds) {
+				newprogress = ((ProgressRounds) newprogress).advance();
+			}
+		}
+		return new SHAOPState(newactions, connections, newprogress, settings,
+				null, newActor, partyNumbers, newSpent);
+
+	}
+
+	/**
+	 * party that did a real action
+	 * 
+	 * @param actor
+	 * @param action
+	 * @return new state.
+	 * @throws ProtocolException
+	 */
+	private SHAOPState withShaopRealAction(PartyId actor, Action action)
+			throws IllegalArgumentException {
+		if (!isShaopParty(actor))
+			throw new IllegalArgumentException(
+					"Illegal action for COB party" + action);
+		// real action only allowed if party has the turn.
+		if (!actor.equals(connections.get(actorNr).getParty())) {
+			throw new IllegalArgumentException("Party does not have the turn ");
+		}
+		// check protocol is followed for specific actions
+		if (action instanceof Accept) {
+			Bid bid = getLastBid();
+			if (bid == null) {
+				throw new IllegalArgumentException(
+						"Accept without a recent offer");
+			}
+			if (!bid.equals(((Accept) action).getBid())) {
+				throw new IllegalArgumentException(
+						"Party accepts a bid differing from the last offer ="
+								+ bid + ", action=" + action + ")");
+			}
+		} else if (action instanceof Offer) {
+			// offer is always fine. We don't check if bid is actually in domain
+			// or complete etc. We would need domain for that
+		} else if (action instanceof EndNegotiation) {
+			// just act, we will get into the final state then.
+		} else {
+			throw new IllegalArgumentException(
+					"Action " + action + " is not allowed in SHAOP");
+		}
+		return withAction(action);
+	}
+
+}
